""" aufgabe_ls5_10b.py - Plattenplatz-Prüfer (Ausbauvariante b)
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  13.12.2021, 20.06.2022
    """


import shutil
import os
import string


GRENZWERT = 15 # Grenzwert für Warnung


def laufwerksliste_holen():
    """ Liste der vorhandenen Laufwerke besorgen """
    verfuegbare_laufwerke = ['%s:' % d for d in string.ascii_uppercase if os.path.exists('%s:' % d)]
    return verfuegbare_laufwerke

def plattenplatz_pruefen( laufwerk):
    """ Plattenplatz eines Laufwerks prüfen"""
    gesamt, benutzt, frei = shutil.disk_usage(laufwerk)

    gesamt = round( gesamt / (10**9),2)
    benutzt = round( benutzt / (10**9),2)
    frei = round( frei / (10**9),2)

    benutzt_prozent = round( benutzt/gesamt * 100, 2)
    frei_prozent = round( frei/gesamt * 100, 2)

    print("Laufwerk:", laufwerk)
    print("Gesamt:  ", gesamt,  " GB" )
    print("Benutzt: ", benutzt,  " GB", "(", benutzt_prozent, "% )" )
    print("Frei:    ", frei,  " GB", "(", frei_prozent, "% )" )

    print("")
    if frei_prozent < GRENZWERT:
        print( "Warnung: Plattenplatz", laufwerk, "knapp!")
    else:
        print( "Plattenplatz", laufwerk, "ausreichend.")
    print("")
    print("")


def hauptprogramm():
    """ Hauptprogramm der Laufwerksüberprüfung """
    print( "Plattenplatz-Prüfer (Ausbauvariante b)")
    print( "--------------------------------------")
    print( "")

    laufwerksliste = laufwerksliste_holen()
    for laufwerk in laufwerksliste:
        plattenplatz_pruefen( laufwerk)


hauptprogramm()
