""" aufgabe_ls5_10c.py - Plattenplatz-Prüfer (Ausbauvariante c)
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  13.12.2021, 20.06.2022
    """


import shutil
import os
import string
import dblib


GRENZWERT = 15  # Grenzwert für Warnung


def laufwerksliste_holen():
    """Liste der vorhandenen Laufwerke besorgen"""
    verfuegbare_laufwerke = [
        "%s:" % d for d in string.ascii_uppercase if os.path.exists("%s:" % d)
    ]
    return verfuegbare_laufwerke


def plattenplatz_pruefen(laufwerk):
    """Plattenplatz eines Laufwerks prüfen"""
    gesamt, benutzt, frei = shutil.disk_usage(laufwerk)

    gesamt = round(gesamt / (10 ** 9), 2)
    benutzt = round(benutzt / (10 ** 9), 2)
    frei = round(frei / (10 ** 9), 2)

    return gesamt, benutzt, frei


def plattenplatz_anzeigen(laufwerk, gesamt, benutzt, frei):
    """Plattenplatz anzeigen"""

    benutzt_prozent = round(benutzt / gesamt * 100, 2)
    frei_prozent = round(frei / gesamt * 100, 2)

    print("Laufwerk:", laufwerk)
    print("Gesamt:  ", gesamt, " GB")
    print("Benutzt: ", benutzt, " GB", "(", benutzt_prozent, "% )")
    print("Frei:    ", frei, " GB", "(", frei_prozent, "% )")

    print("")
    if frei_prozent < GRENZWERT:
        print("Warnung: Plattenplatz", laufwerk, "knapp!")
    else:
        print("Plattenplatz", laufwerk, "ausreichend.")
    print("")
    print("")


def db_zugriffswerte():
    """Funktion, die die Zugriffsdaten für eine MySQL-Datenbank liefert"""
    return "localhost", "root", "", "aufgabe_ls5_10c_db"


def plattenplatz_speichern(laufwerk, gesamt, benutzt, frei):
    """Plattenplatzbelegung abspeichern"""
    rechnername = os.environ["COMPUTERNAME"]
    host, user, passwd, db = db_zugriffswerte()
    connection = dblib.db_verbindung_aufbauen(host, user, passwd, db)
    sql_statement = (
        "INSERT INTO plattenplatzbelegung ( rechner, laufwerk, gesamt, benutzt, frei) VALUES ( "
        + "'"
        + str(rechnername)
        + "'"
        + ","
        + "'"
        + str(laufwerk)
        + "'"
        + ","
        + str(gesamt)
        + ","
        + str(benutzt)
        + ","
        + str(frei)
        + ")"
    )
    dblib.db_nicht_abfrage_anweisung(connection, sql_statement)
    dblib.db_verbindung_abbauen(connection)


def hauptprogramm():
    """Hauptprogramm der Laufwerksüberprüfung"""
    print("Plattenplatz-Prüfer (Ausbauvariante c)")
    print("--------------------------------------")
    print("")

    laufwerksliste = laufwerksliste_holen()
    for laufwerk in laufwerksliste:
        gesamt, benutzt, frei = plattenplatz_pruefen(laufwerk)
        plattenplatz_anzeigen(laufwerk, gesamt, benutzt, frei)
        plattenplatz_speichern(laufwerk, gesamt, benutzt, frei)


hauptprogramm()
