""" aufgabe_ls5_12.py - Strombedarfsberechnung
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  15.12.2021, 20.06.2022
    """

import texttable

SPANNUNG = 230  # Spanung in Volt
GRENZWERT = 16  # Max. Strom in Ampere


def geraetedaten_einlesen():
    """ Gerätedaten einlesen"""

    print("Strombedarfsberechnung")
    print("----------------------")
    print("")

    geraete_liste = []
    while True:
        name = str(input("Name des Geräts: "))
        anzahl_geraet = int(input("Anzahl des Geräts: "))
        leistung_geraet = round(float(input("Leistung des Geräts (W): ")), 2)

        geraet = {"name": name, "anzahl": anzahl_geraet,
                  "leistung_einzel": leistung_geraet}
        geraete_liste = geraete_liste + [geraet]
        print("")

        weiter = input("Weiteres Gerät erfassen (j/n): ")
        print("")
        if weiter not in ["j","J"]:
            break

    return geraete_liste


def leistungs_strom_daten_berechnen(geraete_liste):
    """ Leistungs- und Stromdaten pro Gerät berechnen """

    i = 0
    while i < len(geraete_liste):
        # Leistungen und Ströme berechnen
        geraete_liste[i]["stromaufnahme_einzel"] = round(geraete_liste[i]["leistung_einzel"] / SPANNUNG, 2)
        geraete_liste[i]["leistung_gesamt"] = geraete_liste[i]["anzahl"] * geraete_liste[i]["leistung_einzel"]
        geraete_liste[i]["stromaufnahme_gesamt"] = geraete_liste[i]["anzahl"] * geraete_liste[i]["stromaufnahme_einzel"]
        # Leistungen in kW umrechnen
        geraete_liste[i]["leistung_einzel"]= round(geraete_liste[i]["leistung_einzel"]/1000,2)
        geraete_liste[i]["leistung_gesamt"]= round(geraete_liste[i]["leistung_gesamt"]/1000,2)
        i = i + 1


def leistung_strom_total_berechnen(geraete_liste):
    """ Leistung und Strom aller Geräte berechnen """

    leistung_total = 0
    strom_total = 0

    i = 0
    while i < len(geraete_liste):
        leistung_total = leistung_total + geraete_liste[i]["leistung_gesamt"]
        strom_total = strom_total + geraete_liste[i]["stromaufnahme_gesamt"]
        i = i + 1

    return leistung_total, strom_total


def tabelle_ausgeben( geraete_liste):
    """ Tabelle ausgeben mit Hilfe des Moduls texttable """
    ausgabe_tabelle = texttable.Texttable()
    ausgabe_tabelle.set_cols_align(["c", "r", "r", "r", "r", "r"])
    ausgabe_tabelle.set_cols_dtype(["t", "i", "f", "f", "f", "f"])

    ausgabe_tabelle.add_row( ["Name", "Anzahl", "Leistung Einzelgerät (kW)",
        "Stromaufnahme Einzelgerät (A)", "Leistung Gesamt (Wk)", "Stromaufnahme Gesamt (A)"])

    for geraet in geraete_liste:
        ausgabe_tabelle.add_row( [geraet["name"], geraet["anzahl"], geraet["leistung_einzel"],
            geraet["stromaufnahme_einzel"], geraet["leistung_gesamt"], geraet["stromaufnahme_gesamt"]])

    print(ausgabe_tabelle.draw())
    print("")


def total_ausgeben(leistung_total, strom_total):
    """ Werte total und Warnung ausgeben """
    print("")
    print( "Leistung total (kW): ", leistung_total)
    print( "Strom total (A): ", strom_total)
    print("")

    if strom_total > GRENZWERT:
        print( "Warnung: Strom größer", GRENZWERT, "Ampere!")
    else:
        print( "Strom nicht zu groß.")
    print("")


def hauptprogramm():
    """ Funktion, um Gesamtstrombedarf auszurechnen """
    geraete_liste = geraetedaten_einlesen()
    leistungs_strom_daten_berechnen(geraete_liste)
    leistung_total, strom_total = leistung_strom_total_berechnen(geraete_liste)
    tabelle_ausgeben( geraete_liste)
    total_ausgeben(leistung_total, strom_total)

hauptprogramm()
